//+------------------------------------------------------------------+
//|                                          Automated Stop Loss.mq4 |
//|                                       Copyright  2008, TheXpert |
//|                                           TheForEXpert@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, TheXpert"
#property link      "TheForEXpert@gmail.com"

//      
//     ,  99.9% ,    

//   
//    
//
extern int        Differ         = 15;

//  . ,      
// ,  0,       
//
extern int        MinimumProfit  = 0;

//  .
//     .  0,  ,   
//    .   0,    
extern int        Step           = 0;

//  .    .  0,   
//    .   0,   
//   
extern int        Magic          = 0;

bool error = false;

int init()
{
   int stopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL);
   if (Differ < stopLevel)
   {
      Alert(" ", Symbol(), "   c  ( Differ = ", Differ, ",   = ", stopLevel, ")");
      error = true;
   }
   if (Step < 0)   
   {
      Alert(" ", Symbol(), "      ( Step = ", Step, ")");
      error = true;
   }
   if (Magic < 0)   
   {
      Alert(" ", Symbol(), "       ( Magic = ", Magic, ")");
      error = true;
   }
}


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{   
   if (!IsTradeAllowed() || error)
   {
      return (0);
   }
   
   for(int i = OrdersTotal() - 1; i >= 0; i--)
   {
      // already closed
      if(OrderSelect(i, SELECT_BY_POS) == false) continue;
      
      // not current symbol
      if(OrderSymbol() != Symbol()) continue;
      
      if(OrderType() != OP_SELL && OrderType() != OP_BUY) continue;
      
      if(OrderMagicNumber() != Magic && Magic != 0) continue;
      
      int sign = -1;
      double price = Ask;
      
      if(OrderType() == OP_BUY)
      {
         sign = 1;
         price = Bid;
      }
      
      double differ = MathMax(Differ, MarketInfo(Symbol(), MODE_STOPLEVEL))*Point;
      
      double stopLoss = price - differ*sign;     
      double current = OrderStopLoss();
      
      if((stopLoss - OrderOpenPrice())*sign < (MinimumProfit - 0.5)*Point) continue;
      
      if((current - stopLoss)*sign < -0.5*Point || current == 0)
      {
         double startSL = OrderOpenPrice() + MinimumProfit*Point*sign;
         if ((current - startSL)*sign > 0 && current != 0)
         {
            startSL = current;
         }
         
         if ((Step != 0))
         {
            if ((stopLoss - startSL)*sign > (Step - 0.5)*Point)
            {
               stopLoss = startSL + Step*Point*sign;
            }
            else
            {
               stopLoss = startSL;
            }
         }
         
         if (stopLoss != current)
         {
            OrderModify(OrderTicket(), OrderOpenPrice(), stopLoss, OrderTakeProfit(), 0);
            RefreshRates();
         }
      }
   }

   return(0);
}